# -*- coding: utf-8 -*-
#
# This file is part of the parce Python package.
#
# Copyright © 2019-2020 by Wilbert Berendsen <info@wilbertberendsen.nl>
#
# This module is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This module is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


"""
LilyPond words.

Some lists could maybe be generated dynamically.

"""

keywords = (
    'accepts',
    'alias',
    'change',
    'consists',
    'context',
    'defaultchild',
    'denies',
    #'description',
    'etc',  # since 2.20
    #'grobdescriptions',
    'hide', # since 2.18
    'include',
    #'invalid',
    'language',
    'name',
    'new',
    #'objectid',
    'omit', # since 2.18
    'once',
    'set',
    'unset',
    'override',
    'revert',
    'remove',
    'temporary', # since 2.18
    'sequential',
    'simultaneous',
    #'type',
    'undo', # since 2.18 (not mentioned in the command index)
    'version',

    # input modes
    'addlyrics',
    'lyricmode',
    'lyrics',
    'lyricsto',
    'chordmode',
    'chords',
    'drummode',
    'drums',
    'figuremode',
    'figures',
    'notemode',

    # environments:
    'book',
    'bookpart',
    'header',
    'paper',
    'midi',
    'layout',
    'with',
    'score',
)


music_commands = (
    'absolute', # since 2.18
    'acciaccatura',
    'accidentalStyle', # since 2.16
    'addChordShape', # since 2.16
    'addInstrumentDefinition',
    'addQuote',
    'after',         # since 2.23
    'afterGrace',
    #'afterGraceFraction', # this is a parser variable
    'aikenHeads',
    'aikenHeadsMinor',
    'allowPageTurn',
    'alterBroken', # since 2.18 (?)
    'alternative',
    #'AncientRemoveEmptyStaffContext',
    'ambitusAfter', # since 22.1
    'appendToTag', # since 2.16
    'applyContext',
    'applyMusic',
    'applyOutput',
    'appoggiatura',
    'arpeggioArrowDown',
    'arpeggioArrowUp',
    'arpeggioBracket',
    'arpeggioNormal',
    'arpeggioParenthesis',
    'ascendens',
    'auctum',
    'augmentum',
    'autoAccidentals',
    'autoBeamOff',
    'autoBeamOn',
    'autoBreaksOff',            # since 2.20
    'autoBreaksOn',             # since 2.20
    'autoLineBreaksOff',            # since 2.20
    'autoLineBreaksOn',             # since 2.20
    'autoPageBreaksOff',            # since 2.20
    'autoPageBreaksOn',             # since 2.20
    'autochange',
    'balloonGrobText',
    'balloonLengthOff',
    'balloonLengthOn',
    'balloonText',
    'bar',
    'barNumberCheck',
    'bassFigureExtendersOff',
    'bassFigureExtendersOn',
    'bassFigureStaffAlignmentDown',
    'bassFigureStaffAlignmentNeutral',
    'bassFigureStaffAlignmentUp',
    'bendAfter',
    'blackTriangleMarkup',
    'bookOutputName',
    'bookOutputSuffix',
    'bracketCloseSymbol',   # removed in 2.18
    'bracketOpenSymbol',    # removed in 2.18
    'break',
    'breathe',
    'cadenzaOff',
    'cadenzaOn',
    'caesura',
    'cavum',
    #'chordNameSeparator',
    #'chordPrefixSpacer',
    #'chordRootNamer',
    'chordRepeats', # since 2.16
    'clef',
    'compoundMeter', # since 2.16
    'compressFullBarRests',
    'crescHairpin',
    'crescTextCresc',
    'crossStaff', # since 2.16
    'cueClef',  # since 2.16
    'cueClefUnset',  # since 2.16
    'cueDuring',
    'cueDuringWithClef',  # since 2.16
    'dashBar',
    'dashDash',
    'dashDot',
    'dashHat',
    'dashLarger',
    'dashPlus',
    'dashUnderscore',
    'deadNote',         # since 2.16
    'deadNotesOff',     # since 2.20
    'deadNotesOn',      # since 2.20
    'default',
    'defaultNoteHeads',  # since 2.16
    'defaultTimeSignature',
    'defineBarLine', # since 2.18
    'deminutum',
    'descendens',
    'dimHairpin',
    'dimTextDecr',
    'dimTextDecresc',
    'dimTextDim',
    'displayLilyMusic',
    'displayMusic',
    'divisioMaior',
    'divisioMaxima',
    'divisioMinima',
    'dotsDown',
    'dotsNeutral',
    'dotsUp',
    'drumPitchTable',
    'dynamicDown',
    'dynamicNeutral',
    'dynamicUp',
    'easyHeadsOff',
    'easyHeadsOn',
    'endincipit',
    'endSpanners',
    'episemFinis',
    'episemInitium',
    'escapedBiggerSymbol',              # removed in 2.18
    'escapedExclamationSymbol',         # removed in 2.18
    'escapedParenthesisCloseSymbol',    # removed in 2.18
    'escapedParenthesisOpenSymbol',     # removed in 2.18
    'escapedSmallerSymbol',             # removed in 2.18
    'expandFullBarRests',
    'featherDurations',
    'fermataMarkup',
    'finalis',
    'fingeringOrientations',
    'fixed',    # since 2.20
    'flexa',
    'frenchChords',
    'fullJazzExceptions',
    'funkHeads',
    'funkHeadsMinor',
    'germanChords',
    'grace',
    'graceSettings',
    'harmonic',
    'harmonicsOff',
    'harmonicsOn',
    'hideNotes',
    'hideStaffSwitch',
    'huge',
    'ignatzekExceptionMusic',
    'ignatzekExceptions',
    'iij',
    'IIJ',
    'ij',
    'IJ',
    'improvisationOff',
    'improvisationOn',
    'inclinatum',
    'includePageLayoutFile',
    'indent',
    'inStaffSegno', # since 2.16
    'instrumentSwitch',
    'instrumentTransposition',
    'interscoreline',
    'italianChords',
    'keepWithTag',
    'key',
    'kievanOff',            # since 2.20
    'kievanOn',             # since 2.20
    'killCues',
    'label',
    'large',
    'ligature',
    'linea',
    'maininput',
    #'majorSevenSymbol',    # not used as a command
    'makeClusters',
    'mark',
    'markLengthOff', # since 2.18
    'markLengthOn',  # since 2.18
    'markup',
    'markuplines', # deprecated, till 2.14
    'markuplist', # from 2.16
    'mergeDifferentlyDottedOff',
    'mergeDifferentlyDottedOn',
    'mergeDifferentlyHeadedOff',
    'mergeDifferentlyHeadedOn',
    'musicMap',
    'neumeDemoLayout',
    'newSpacingSection',
    'noBeam',
    'noBreak',
    'noPageBreak',
    'noPageTurn',
    'normalsize',
    'numericTimeSignature',
    'octaveCheck',
    'oldaddlyrics',
    'oneVoice',
    'oriscus',
    'ottava',
    'overrideProperty',
    'overrideTimeSignatureSettings',  # since 2.16
    'pageBreak',
    'pageTurn',
    'palmMute',  # since 2.16
    'palmMuteOn',  # since 2.16
    'parallelMusic',
    'parenthesisCloseSymbol',       # removed in 2.18
    'parenthesisOpenSymbol',        # removed in 2.18
    'parenthesize',
    'partcombine',
    'partCombineListener',
    'partial',
    'partialJazzExceptions',
    'partialJazzMusic',
    'pes',
    'phrasingSlurDashed',
    'phrasingSlurDotted',
    'phrasingSlurDown',
    'phrasingSlurNeutral',
    'phrasingSlurSolid',
    'phrasingSlurUp',
    'pipeSymbol',                   # removed in 2.18
    'pitchedTrill',
    'pointAndClickOff',
    'pointAndClickOn',
    'predefinedFretboardsOff',
    'predefinedFretboardsOn',
    'pushToTag', # since 2.16
    'quilisma',
    'quoteDuring',
    'relative',
    'RemoveEmptyRhythmicStaffContext',
    'RemoveEmptyStaffContext',
    'removeWithTag',
    'repeat',
    'resetRelativeOctave',
    'responsum',
    'rest',
    'rightHandFinger',
    'sacredHarpHeads',
    'sacredHarpHeadsMinor',
    'scaleDurations',
    'scoreTweak',
    'semiGermanChords',
    'shape', # since 2.16
    'shiftDurations',
    'shiftOff',
    'shiftOn',
    'shiftOnn',
    'shiftOnnn',
    'showStaffSwitch',
    'single', # since 2.18
    'skip',
    'skipTypesetting',
    'slurDashed',
    'slurDotted',
    'slurDown',
    'slurNeutral',
    'slurSolid',
    'slurUp',
    'small',
    'sostenutoOff',
    'sostenutoOn',
    'southernHarmonyHeads',
    'southernHarmonyHeadsMinor',
    'spacingTweaks',
    'startAcciaccaturaMusic',
    'startAppoggiaturaMusic',
    'startGraceMusic',
    'startGroup',
    'startStaff',
    'stemDown',
    'stemNeutral',
    'stemUp',
    'stopAcciaccaturaMusic',
    'stopAppoggiaturaMusic',
    'stopGraceMusic',
    'stopGroup',
    'stopStaff',
    'stringTuning', # since 2.16
    'strokeFingerOrientations',
    'stropha',
    'sustainOff',
    'sustainOn',
    'tabFullNotation',
    'tag',
    'tagGroup',     # since 2.20
    'teeny',
    'tempo',
    'tempoWholesPerMinute',
    'textLengthOff',
    'textLengthOn',
    'textSpannerDown',
    'textSpannerNeutral',
    'textSpannerUp',
    'tieDashed',
    'tieDotted',
    'tieDown',
    'tieNeutral',
    'tieSolid',
    'tieUp',
    'tildeSymbol',          # removed in 2.18
    'time',
    'times',    # not mentioned since 2.18 (superseded by \tuplet)
    'timing',
    'tiny',
    'tocItem', # since ?
    'transpose',
    'transposedCueDuring',
    'transposition',
    'treCorde',
    'tuplet', # since 2.18
    'tupletDown',
    'tupletNeutral',
    'tupletUp',
    'tweak',
    'unaCorda',
    'unfolded',     # since 2.23
    'unfoldRepeats',
    'unHideNotes',
    'unit',
    'versus',
    'virga',
    'virgula',
    'vshape',       # since 2.23
    'voiceFour',
    'voiceFourStyle',
    'voiceNeutralStyle',
    'voiceOne',
    'voiceOneStyle',
    'voiceThree',
    'voiceThreeStyle',
    'voiceTwo',
    'voiceTwoStyle',
    'volta',    # since 2.23
    'walkerHeads',
    'walkerHeadsMinor',
    'whiteTriangleMarkup',
    'withMusicProperty',
    'xNotesOff',
    'xNotesOn',
)

units = (
    'mm',
    'cm',
    'in',
    'pt',
)

markup_commands_nargs = (
# no arguments
(
    'doubleflat',
    'doublesharp',
    'draw-hline',       # since 2.14
    'eyeglasses',
    'fermata',          # since 2.18
    'flat',
    'natural',
    'null',
    'semiflat',
    'semisharp',
    'sesquiflat',
    'sesquisharp',
    'sharp',
    'strut',
    'table-of-contents'
),
# one argument
(
    'backslashed-digit',
    'bold',
    'box',
    'bracket',
    'caps',
    'center-align',
    'center-column',
    'char',
    'circle',
    'column',
    'column-lines',     # since 2.14
    'concat',
    'compound-meter',   # since 2.22
    'dir-column',
    'discant',          # since 2.20
    'draw-dashed-line', # since 2.18
    'draw-dotted-line', # since 2.18
    'draw-line',
    'dynamic',
    'ellipse',          # since 2.20
    'fill-line',
    'finger',
    'first-visible',    # since 2.20
    'fontCaps',
    'freeBass',         # since 2.20 #(use-modules (scm accreg))
    'fret-diagram',
    'fret-diagram-terse',
    'fret-diagram-verbose',
    'fromproperty',
    'harp-pedal',
    'hbracket',
    'hspace',
    'huge',
    'italic',
    'justify',
    'justify-field',
    'justify-line',     # since 2.20
    'justify-string',
    'large',
    'larger',
    'left-align',
    'left-brace',
    'left-column',
    'line',
    'lookup',
    'markalphabet',
    'markletter',
    'medium',
    'musicglyph',
    'normalsize',
    'normal-size-sub',
    'normal-size-super',
    'normal-text',
    'number',
    'oval',         # since 2.18
    'overlay',      # since 2.20
    'overtie',      # since 2.20
    'parenthesize', # since 2.14
    'postscript',
    'property-recursive',   # since 2.16
    'rest',         # since 2.20
    'right-align',
    'right-brace',
    'right-column',
    'roman',
    'rounded-box',
    'sans',
    'score',
    'score-lines',  # since 2.20
    'simple',
    'slashed-digit',
    'small',
    'smallCaps',
    'smaller',
    'stdBase',      # since 2.20 #(use-modules (scm accreg))
    'stdBaseIV',    # since 2.20 #(use-modules (scm accreg))
    'stdBaseV',     # since 2.20 #(use-modules (scm accreg))
    'stdBaseVI',    # since 2.20 #(use-modules (scm accreg))
    'stencil',
    'sub',
    'super',
    'teeny',
    'text',
    'tie',          # since 2.20
    'tied-lyric',
    'tiny',
    'transparent',
    'triangle',
    'typewriter',
    'underline',
    'undertie',     # since 2.20
    'upright',
    'vcenter',
    'vspace',
    'verbatim-file',
    'whiteout',
    'wordwrap',
    'wordwrap-field',
    'wordwrap-string',
),
# two arguments
(
    'abs-fontsize',
    'auto-footnote', # since 2.16
    'combine',
    'customTabClef',
    'fontsize',
    'footnote',
    'fraction',
    'halign',
    'hcenter-in',
    'if',       # since 2.23
    'lower',
    'magnify',
    'map-markup-commands',  # since 2.20
    'note',
    'on-the-fly',
    'override',
    'override-lines',       # since 2.12
    'pad-around',
    'pad-markup',
    'pad-x',
    'page-link',
    'path',         # since 2.14
    'raise',
    'replace',      # since 2.20
    'rest-by-number',   # since 2.20
    'rotate',
    'scale',
    'table',        # since 2.20
    'translate',
    'translate-scaled',
    'unless',       # since 2.23
    'with-color',
    'with-dimensions-from', # since 2.20
    'with-link',
    'with-outline',     # since 2.20
    'with-url',
    'woodwind-diagram',
),
# three arguments
(
    'arrow-head',
    'beam',
    'draw-circle',
    'draw-squiggle-line',   # since 2.20
    'epsfile',
    'filled-box',
    'general-align',
    'note-by-number',
    'pad-to-box',
    'page-ref',
    'with-dimensions',
),
# four arguments
(
    'pattern',
    'put-adjacent',
),
# five arguments,
(
    'fill-with-pattern',
),
)

markup_commands = {}
for n, cmds in enumerate(markup_commands_nargs):
    markup_commands.update(dict.fromkeys(cmds, n))
del n, cmds


dynamics = (
    "n",    # niente, since 2.22
    "ppppp",
    "pppp",
    "ppp",
    "pp",
    "p",
    "mp",
    "mf",
    "f",
    "ff",
    "fff",
    "ffff",
    "fffff",

    "fp",
    "sf",
    "sfp",
    "sff",
    "sfz",
    "fz",   # undocumented
    "sp",
    "spp",
    "rfz",

    # dynamic spanners:
    "cr",
    "decr",
    "enddecr",
    "endcr",
    "cresc",
    "endcresc",
    "dim",
    "enddim",
    "decresc",
    "enddecresc",
)


articulations = (
    'accent',
    'espressivo',
    'marcato',
    'portato',
    'staccatissimo',
    'staccato',
    'tenuto',
)


ornaments = (
    'prall',
    'prallup',
    'pralldown',
    'upprall',
    'downprall',
    'prallprall',
    'lineprall',
    'prallmordent',
    'mordent',
    'upmordent',
    'downmordent',
    'trill',
    'turn',
    'reverseturn',
    'slashturn',
    'haydnturn',
)


fermatas = (
    'veryshortfermata',
    'shortfermata',
    'fermata',
    'longfermata',
    'verylongfermata',
    'henzeshortfermata',
    'henzelongfermata',
)


instrument_scripts = (
    'upbow',
    'downbow',
    'flageolet',
    'open',
    'halfopen',
    'lheel',
    'rheel',
    'ltoe',
    'rtoe',
    'snappizzicato',
    'stopped',
    'thumb',
)


repeat_scripts = (
    'segno',
    'coda',
    'varcoda',
)


ancient_scripts = (
    'accentus',
    'circulus',
    'ictus',
    'semicirculus',
    'signumcongruentiae',
)


# these spanner events are also articulations in LilyPond
spanner_events = (
    'startTextSpan',
    'stopTextSpan',
    'startTrillSpan',
    'stopTrillSpan',
    'repeatTie',
    'laissezVibrer',
    'melisma',
    'melismaEnd',
    'arpeggio',
    'glissando',
)


all_articulations = (
    articulations + ornaments + fermatas + instrument_scripts +
    repeat_scripts + ancient_scripts + spanner_events
)


modes = (
    'major',
    'minor',
    'ionian',
    'dorian',
    'phrygian',
    'lydian',
    'mixolydian',
    'aeolian',
    'locrian',
)


contexts = (
    'ChoirStaff',
    'ChordNames',
    'CueVoice',
    'Devnull',
    'DrumStaff',
    'DrumVoice',
    'Dynamics',
    'FiguredBass',
    'FretBoards',
    'Global',
    'GrandStaff',
    'GregorianTranscriptionStaff',
    'GregorianTranscriptionVoice',
    'KievanStaff', # since 2.16
    'KievanVoice', # since 2.16
    'Lyrics',
    'MensuralStaff',
    'MensuralVoice',
    'NoteNames',
    'NullVoice',     # since 2.18
    'OneStaff',      # since 2.20
    'PetrucciStaff', # since 2.16
    'PetrucciVoice', # since 2.16
    'PianoStaff',
    'RhythmicStaff',
    'Score',
    'Staff',
    'StaffGroup',
    'TabStaff',
    'TabVoice',
    'Timing',        # not a real context, but an alias created by Timing_translator
    'VaticanaStaff',
    'VaticanaVoice',
    'Voice',
)

grobs = (
    'Accidental',
    'AccidentalCautionary',
    'AccidentalPlacement',
    'AccidentalSuggestion',
    'Ambitus',
    'AmbitusAccidental',
    'AmbitusLine',
    'AmbitusNoteHead',
    'Arpeggio',
    'BalloonTextItem',
    'BalloonTextSpanner',   # since 2.22
    'BarLine',
    'BarNumber',
    'BassFigure',
    'BassFigureAlignment',
    'BassFigureAlignmentPositioning',
    'BassFigureBracket',
    'BassFigureContinuation',
    'BassFigureLine',
    'Beam',
    'BendAfter',
    'BreakAlignGroup',
    'BreakAlignment',
    'BreathingSign',
    'ChordName',
    'Clef',
    'ClefModifier',
    'ClusterSpanner',
    'ClusterSpannerBeacon',
    'CombineTextScript',
    'CueClef',
    'CueEndClef',
    'Custos',
    'DotColumn',
    'Dots',
    'DoublePercentRepeat',
    'DoublePercentRepeatCounter',
    'DoubleRepeatSlash',
    'DurationLine',         # since 2.22
    'DynamicLineSpanner',
    'DynamicText',
    'DynamicTextSpanner',
    'Episema',
    'Fingering',
    'FingeringColumn',
    'Flag',
    'FootnoteItem',
    'FootnoteSpanner',
    'FretBoard',
    'Glissando',
    'GraceSpacing',
    'GridLine',
    'GridPoint',
    'Hairpin',
    'HorizontalBracket',
    'HorizontalBracketText',    # since 2.20
    'InstrumentName',
    'InstrumentSwitch',
    'KeyCancellation',
    'KeySignature',
    'KievanLigature',
    'LaissezVibrerTie',
    'LaissezVibrerTieColumn',
    'LedgerLineSpanner',
    'LeftEdge',
    'LigatureBracket',
    'LyricExtender',
    'LyricHyphen',
    'LyricSpace',
    'LyricText',
    'MeasureCounter',
    'MeasureGrouping',
    'MeasureSpanner',           # since 2.22
    'MelodyItem',
    'MensuralLigature',
    'MetronomeMark',
    'MultiMeasureRest',
    'MultiMeasureRestNumber',
    'MultiMeasureRestScript',   # since 2.22
    'MultiMeasureRestText',
    'NonMusicalPaperColumn',
    'NoteCollision',
    'NoteColumn',
    'NoteHead',
    'NoteName',
    'NoteSpacing',
    'OttavaBracket',
    'PaperColumn',
    'ParenthesesItem',
    'PercentRepeat',
    'PercentRepeatCounter',
    'PhrasingSlur',
    'PianoPedalBracket',
    'RehearsalMark',
    'RepeatSlash',
    'RepeatTie',
    'RepeatTieColumn',
    'Rest',
    'RestCollision',
    'Script',
    'ScriptColumn',
    'ScriptRow',
    'Slur',
    'SostenutoPedal',
    'SostenutoPedalLineSpanner',
    'SpacingSpanner',
    'SpanBar',
    'SpanBarStub',
    'StaffGrouper',
    'StaffSpacing',
    'StaffSymbol',
    'StanzaNumber',
    'Stem',
    'StemStub',
    'StemTremolo',
    'StringNumber',
    'StrokeFinger',
    'SustainPedal',
    'SustainPedalLineSpanner',
    'System',
    'SystemStartBar',
    'SystemStartBrace',
    'SystemStartBracket',
    'SystemStartSquare',
    'TabNoteHead',
    'TextScript',
    'TextSpanner',
    'Tie',
    'TieColumn',
    'TimeSignature',
    'TrillPitchAccidental',
    'TrillPitchGroup',
    'TrillPitchHead',
    'TrillSpanner',
    'TupletBracket',
    'TupletNumber',
    'UnaCordaPedal',
    'UnaCordaPedalLineSpanner',
    'VaticanaLigature',
    'VerticalAlignment',
    'VerticalAxisGroup',
    'VoiceFollower',
    'VoltaBracket',
    'VoltaBracketSpanner',
)


# alterations
from fractions import Fraction
DOUBLE_FLAT     = -1
THREE_Q_FLAT    = -0.75
FLAT            = -0.5
SEMI_FLAT       = -0.25
NATURAL         =  0
SEMI_SHARP      =  0.25
SHARP           =  0.5
THREE_Q_SHARP   =  0.75
DOUBLE_SHARP    =  1
FIVE_HALF_FLAT  = -2.5
SEVEN_HALF_FLAT =  Fraction(-7, 2)
FIVE_HALF_SHARP =  2.5
SEVEN_HALF_SHARP=  Fraction(7, 2)

pitch_names = {
    "nederlands": {
        "ceses": (-1, 0, DOUBLE_FLAT),
        "ceseh": (-1, 0, THREE_Q_FLAT),
        "ces": (-1, 0, FLAT),
        "ceh": (-1, 0, SEMI_FLAT),
        "c": (-1, 0, NATURAL),
        "cih": (-1, 0, SEMI_SHARP),
        "cis": (-1, 0, SHARP),
        "cisih": (-1, 0, THREE_Q_SHARP),
        "cisis": (-1, 0, DOUBLE_SHARP),

        "deses": (-1, 1, DOUBLE_FLAT),
        "deseh": (-1, 1, THREE_Q_FLAT),
        "des": (-1, 1, FLAT),
        "deh": (-1, 1, SEMI_FLAT),
        "d": (-1, 1, NATURAL),
        "dih": (-1, 1, SEMI_SHARP),
        "dis": (-1, 1, SHARP),
        "disih": (-1, 1, THREE_Q_SHARP),
        "disis": (-1, 1, DOUBLE_SHARP),

        "eeses": (-1, 2, DOUBLE_FLAT),
        "eses": (-1, 2, DOUBLE_FLAT),
        "eeseh": (-1, 2, THREE_Q_FLAT),
        "ees": (-1, 2, FLAT),
        "es": (-1, 2, FLAT),
        "eeh": (-1, 2, SEMI_FLAT),
        "e": (-1, 2, NATURAL),
        "eih": (-1, 2, SEMI_SHARP),
        "eis": (-1, 2, SHARP),
        "eisih": (-1, 2, THREE_Q_SHARP),
        "eisis": (-1, 2, DOUBLE_SHARP),

        "feses": (-1, 3, DOUBLE_FLAT),
        "feseh": (-1, 3, THREE_Q_FLAT),
        "fes": (-1, 3, FLAT),
        "feh": (-1, 3, SEMI_FLAT),
        "f": (-1, 3, NATURAL),
        "fih": (-1, 3, SEMI_SHARP),
        "fis": (-1, 3, SHARP),
        "fisih": (-1, 3, THREE_Q_SHARP),
        "fisis": (-1, 3, DOUBLE_SHARP),

        "geses": (-1, 4, DOUBLE_FLAT),
        "geseh": (-1, 4, THREE_Q_FLAT),
        "ges": (-1, 4, FLAT),
        "geh": (-1, 4, SEMI_FLAT),
        "g": (-1, 4, NATURAL),
        "gih": (-1, 4, SEMI_SHARP),
        "gis": (-1, 4, SHARP),
        "gisih": (-1, 4, THREE_Q_SHARP),
        "gisis": (-1, 4, DOUBLE_SHARP),

        "aeses": (-1, 5, DOUBLE_FLAT),
        "ases": (-1, 5, DOUBLE_FLAT),
        "aeseh": (-1, 5, THREE_Q_FLAT),
        "aes": (-1, 5, FLAT),
        "as": (-1, 5, FLAT),
        "aeh": (-1, 5, SEMI_FLAT),
        "a": (-1, 5, NATURAL),
        "aih": (-1, 5, SEMI_SHARP),
        "ais": (-1, 5, SHARP),
        "aisih": (-1, 5, THREE_Q_SHARP),
        "aisis": (-1, 5, DOUBLE_SHARP),

        "beses": (-1, 6, DOUBLE_FLAT),
        "beseh": (-1, 6, THREE_Q_FLAT),
        "bes": (-1, 6, FLAT),
        "beh": (-1, 6, SEMI_FLAT),
        "b": (-1, 6, NATURAL),
        "bih": (-1, 6, SEMI_SHARP),
        "bis": (-1, 6, SHARP),
        "bisih": (-1, 6, THREE_Q_SHARP),
        "bisis": (-1, 6, DOUBLE_SHARP),
    },
    "arabic": {
        "c": (-1, 0, NATURAL),
        "d": (-1, 1, NATURAL),
        "e": (-1, 2, NATURAL),
        "f": (-1, 3, NATURAL),
        "g": (-1, 4, NATURAL),
        "a": (-1, 5, NATURAL),
        "b": (-1, 6, NATURAL),

        "cd": (-1, 0, SHARP),
        "dd": (-1, 1, SHARP),
        "ed": (-1, 2, SHARP),
        "fd": (-1, 3, SHARP),
        "gd": (-1, 4, SHARP),
        "ad": (-1, 5, SHARP),
        "bd": (-1, 6, SHARP),

        "cb": (-1, 0, FLAT),
        "db": (-1, 1, FLAT),
        "eb": (-1, 2, FLAT),
        "fb": (-1, 3, FLAT),
        "gb": (-1, 4, FLAT),
        "ab": (-1, 5, FLAT),
        "bb": (-1, 6, FLAT),

        "cdd": (-1, 0, SEMI_SHARP),
        "ddd": (-1, 1, SEMI_SHARP),
        "edd": (-1, 2, SEMI_SHARP),
        "fdd": (-1, 3, SEMI_SHARP),
        "gdd": (-1, 4, SEMI_SHARP),
        "add": (-1, 5, SEMI_SHARP),
        "bdd": (-1, 6, SEMI_SHARP),

        "cdb": (-1, 0, SEMI_FLAT),
        "ddb": (-1, 1, SEMI_FLAT),
        "edb": (-1, 2, SEMI_FLAT),
        "fdb": (-1, 3, SEMI_FLAT),
        "gdb": (-1, 4, SEMI_FLAT),
        "adb": (-1, 5, SEMI_FLAT),
        "bdb": (-1, 6, SEMI_FLAT),

        "ctqb": (-1, 0, THREE_Q_FLAT),
        "dtqb": (-1, 1, THREE_Q_FLAT),
        "etqb": (-1, 2, THREE_Q_FLAT),
        "ftqb": (-1, 3, THREE_Q_FLAT),
        "gtqb": (-1, 4, THREE_Q_FLAT),
        "atqb": (-1, 5, THREE_Q_FLAT),
        "btqb": (-1, 6, THREE_Q_FLAT),

        "ctqd": (-1, 0, THREE_Q_SHARP),
        "dtqd": (-1, 1, THREE_Q_SHARP),
        "etqd": (-1, 2, THREE_Q_SHARP),
        "ftqd": (-1, 3, THREE_Q_SHARP),
        "gtqd": (-1, 4, THREE_Q_SHARP),
        "atqd": (-1, 5, THREE_Q_SHARP),
        "btqd": (-1, 6, THREE_Q_SHARP),

        "cfhb": (-1, 0, FIVE_HALF_FLAT),
        "dfhb": (-1, 1, FIVE_HALF_FLAT),
        "efhb": (-1, 2, FIVE_HALF_FLAT),
        "ffhb": (-1, 3, FIVE_HALF_FLAT),
        "gfhb": (-1, 4, FIVE_HALF_FLAT),
        "afhb": (-1, 5, FIVE_HALF_FLAT),
        "bfhb": (-1, 6, FIVE_HALF_FLAT),

        "cfhd": (-1, 0, FIVE_HALF_SHARP),
        "dfhd": (-1, 1, FIVE_HALF_SHARP),
        "efhd": (-1, 2, FIVE_HALF_SHARP),
        "ffhd": (-1, 3, FIVE_HALF_SHARP),
        "gfhd": (-1, 4, FIVE_HALF_SHARP),
        "afhd": (-1, 5, FIVE_HALF_SHARP),
        "bfhd": (-1, 6, FIVE_HALF_SHARP),

        "cshb": (-1, 0, SEVEN_HALF_FLAT),
        "dshb": (-1, 1, SEVEN_HALF_FLAT),
        "eshb": (-1, 2, SEVEN_HALF_FLAT),
        "fshb": (-1, 3, SEVEN_HALF_FLAT),
        "gshb": (-1, 4, SEVEN_HALF_FLAT),
        "ashb": (-1, 5, SEVEN_HALF_FLAT),
        "bshb": (-1, 6, SEVEN_HALF_FLAT),

        "cshd": (-1, 0, SEVEN_HALF_SHARP),
        "dshd": (-1, 1, SEVEN_HALF_SHARP),
        "eshd": (-1, 2, SEVEN_HALF_SHARP),
        "fshd": (-1, 3, SEVEN_HALF_SHARP),
        "gshd": (-1, 4, SEVEN_HALF_SHARP),
        "ashd": (-1, 5, SEVEN_HALF_SHARP),
        "bshd": (-1, 6, SEVEN_HALF_SHARP),
    },
    "catalan": {
        "dobb": (-1, 0, DOUBLE_FLAT),
        "dob": (-1, 0, FLAT),
        "do": (-1, 0, NATURAL),
        "dod": (-1, 0, SHARP),
        "dodd": (-1, 0, DOUBLE_SHARP),

        "rebb": (-1, 1, DOUBLE_FLAT),
        "reb": (-1, 1, FLAT),
        "re": (-1, 1, NATURAL),
        "red": (-1, 1, SHARP),
        "redd": (-1, 1, DOUBLE_SHARP),

        "mibb": (-1, 2, DOUBLE_FLAT),
        "mib": (-1, 2, FLAT),
        "mi": (-1, 2, NATURAL),
        "mid": (-1, 2, SHARP),
        "midd": (-1, 2, DOUBLE_SHARP),

        "fabb": (-1, 3, DOUBLE_FLAT),
        "fab": (-1, 3, FLAT),
        "fa": (-1, 3, NATURAL),
        "fad": (-1, 3, SHARP),
        "fadd": (-1, 3, DOUBLE_SHARP),

        "solbb": (-1, 4, DOUBLE_FLAT),
        "solb": (-1, 4, FLAT),
        "sol": (-1, 4, NATURAL),
        "sold": (-1, 4, SHARP),
        "soldd": (-1, 4, DOUBLE_SHARP),

        "labb": (-1, 5, DOUBLE_FLAT),
        "lab": (-1, 5, FLAT),
        "la": (-1, 5, NATURAL),
        "lad": (-1, 5, SHARP),
        "ladd": (-1, 5, DOUBLE_SHARP),

        "sibb": (-1, 6, DOUBLE_FLAT),
        "sib": (-1, 6, FLAT),
        "si": (-1, 6, NATURAL),
        "sid": (-1, 6, SHARP),
        "sidd": (-1, 6, DOUBLE_SHARP),

        # deprecated?
        "dos": (-1, 0, SHARP),
        "doss": (-1, 0, DOUBLE_SHARP),
        "res": (-1, 1, SHARP),
        "ress": (-1, 1, DOUBLE_SHARP),
        "mis": (-1, 2, SHARP),
        "miss": (-1, 2, DOUBLE_SHARP),
        "fas": (-1, 3, SHARP),
        "fass": (-1, 3, DOUBLE_SHARP),
        "sols": (-1, 4, SHARP),
        "solss": (-1, 4, DOUBLE_SHARP),
        "las": (-1, 5, SHARP),
        "lass": (-1, 5, DOUBLE_SHARP),
        "sis": (-1, 6, SHARP),
        "siss": (-1, 6, DOUBLE_SHARP),
    },
    "deutsch": {
        "ceses": (-1, 0, DOUBLE_FLAT),
        "ceseh": (-1, 0, THREE_Q_FLAT),
        "ces": (-1, 0, FLAT),
        "ceh": (-1, 0, SEMI_FLAT),
        "c": (-1, 0, NATURAL),
        "cih": (-1, 0, SEMI_SHARP),
        "cis": (-1, 0, SHARP),
        "cisih": (-1, 0, THREE_Q_SHARP),
        "cisis": (-1, 0, DOUBLE_SHARP),

        "deses": (-1, 1, DOUBLE_FLAT),
        "deseh": (-1, 1, THREE_Q_FLAT),
        "des": (-1, 1, FLAT),
        "deh": (-1, 1, SEMI_FLAT),
        "d": (-1, 1, NATURAL),
        "dih": (-1, 1, SEMI_SHARP),
        "dis": (-1, 1, SHARP),
        "disih": (-1, 1, THREE_Q_SHARP),
        "disis": (-1, 1, DOUBLE_SHARP),

        "eses": (-1, 2, DOUBLE_FLAT),
        "eseh": (-1, 2, THREE_Q_FLAT),
        "es": (-1, 2, FLAT),
        "eeh": (-1, 2, SEMI_FLAT), # should be eh; kept for backward compatibility
        "eh": (-1, 2, SEMI_FLAT),
        "e": (-1, 2, NATURAL),
        "eih": (-1, 2, SEMI_SHARP),
        "eis": (-1, 2, SHARP),
        "eisih": (-1, 2, THREE_Q_SHARP),
        "eisis": (-1, 2, DOUBLE_SHARP),

        "feses": (-1, 3, DOUBLE_FLAT),
        "feseh": (-1, 3, THREE_Q_FLAT),
        "fes": (-1, 3, FLAT),
        "feh": (-1, 3, SEMI_FLAT),
        "f": (-1, 3, NATURAL),
        "fih": (-1, 3, SEMI_SHARP),
        "fis": (-1, 3, SHARP),
        "fisih": (-1, 3, THREE_Q_SHARP),
        "fisis": (-1, 3, DOUBLE_SHARP),

        "geses": (-1, 4, DOUBLE_FLAT),
        "geseh": (-1, 4, THREE_Q_FLAT),
        "ges": (-1, 4, FLAT),
        "geh": (-1, 4, SEMI_FLAT),
        "g": (-1, 4, NATURAL),
        "gih": (-1, 4, SEMI_SHARP),
        "gis": (-1, 4, SHARP),
        "gisih": (-1, 4, THREE_Q_SHARP),
        "gisis": (-1, 4, DOUBLE_SHARP),

        "asas": (-1, 5, DOUBLE_FLAT),
        "ases": (-1, 5, DOUBLE_FLAT),   # non-standard name for asas
        "asah": (-1, 5, THREE_Q_FLAT),
        "aseh": (-1, 5, THREE_Q_FLAT),  # non-standard name for asah
        "as": (-1, 5, FLAT),
        "aeh": (-1, 5, SEMI_FLAT),  # should be ah; kepy for backward compatibility
        "ah": (-1, 5, SEMI_FLAT),
        "a": (-1, 5, NATURAL),
        "aih": (-1, 5, SEMI_SHARP),
        "ais": (-1, 5, SHARP),
        "aisih": (-1, 5, THREE_Q_SHARP),
        "aisis": (-1, 5, DOUBLE_SHARP),

        "heses": (-1, 6, DOUBLE_FLAT),
        "heseh": (-1, 6, THREE_Q_FLAT),
        "b": (-1, 6, FLAT),
        "beh": (-1, 6, SEMI_FLAT),
        "h": (-1, 6, NATURAL),
        "hih": (-1, 6, SEMI_SHARP),
        "his": (-1, 6, SHARP),
        "hisih": (-1, 6, THREE_Q_SHARP),
        "hisis": (-1, 6, DOUBLE_SHARP),
    },
    "english": {
        "cff": (-1, 0, DOUBLE_FLAT),
        "ctqf": (-1, 0, THREE_Q_FLAT),
        "cf": (-1, 0, FLAT),
        "cqf": (-1, 0, SEMI_FLAT),
        "c": (-1, 0, NATURAL),
        "cqs": (-1, 0, SEMI_SHARP),
        "cs": (-1, 0, SHARP),
        "ctqs": (-1, 0, THREE_Q_SHARP),
        "css": (-1, 0, DOUBLE_SHARP),
        "cx": (-1, 0, DOUBLE_SHARP),

        "dff": (-1, 1, DOUBLE_FLAT),
        "dtqf": (-1, 1, THREE_Q_FLAT),
        "df": (-1, 1, FLAT),
        "dqf": (-1, 1, SEMI_FLAT),
        "d": (-1, 1, NATURAL),
        "dqs": (-1, 1, SEMI_SHARP),
        "ds": (-1, 1, SHARP),
        "dtqs": (-1, 1, THREE_Q_SHARP),
        "dss": (-1, 1, DOUBLE_SHARP),
        "dx": (-1, 1, DOUBLE_SHARP),

        "eff": (-1, 2, DOUBLE_FLAT),
        "etqf": (-1, 2, THREE_Q_FLAT),
        "ef": (-1, 2, FLAT),
        "eqf": (-1, 2, SEMI_FLAT),
        "e": (-1, 2, NATURAL),
        "eqs": (-1, 2, SEMI_SHARP),
        "es": (-1, 2, SHARP),
        "etqs": (-1, 2, THREE_Q_SHARP),
        "ess": (-1, 2, DOUBLE_SHARP),
        "ex": (-1, 2, DOUBLE_SHARP),

        "fff": (-1, 3, DOUBLE_FLAT),
        "ftqf": (-1, 3, THREE_Q_FLAT),
        "ff": (-1, 3, FLAT),
        "fqf": (-1, 3, SEMI_FLAT),
        "f": (-1, 3, NATURAL),
        "fqs": (-1, 3, SEMI_SHARP),
        "fs": (-1, 3, SHARP),
        "ftqs": (-1, 3, THREE_Q_SHARP),
        "fss": (-1, 3, DOUBLE_SHARP),
        "fx": (-1, 3, DOUBLE_SHARP),

        "gff": (-1, 4, DOUBLE_FLAT),
        "gtqf": (-1, 4, THREE_Q_FLAT),
        "gf": (-1, 4, FLAT),
        "gqf": (-1, 4, SEMI_FLAT),
        "g": (-1, 4, NATURAL),
        "gqs": (-1, 4, SEMI_SHARP),
        "gs": (-1, 4, SHARP),
        "gtqs": (-1, 4, THREE_Q_SHARP),
        "gss": (-1, 4, DOUBLE_SHARP),
        "gx": (-1, 4, DOUBLE_SHARP),

        "aff": (-1, 5, DOUBLE_FLAT),
        "atqf": (-1, 5, THREE_Q_FLAT),
        "af": (-1, 5, FLAT),
        "aqf": (-1, 5, SEMI_FLAT),
        "a": (-1, 5, NATURAL),
        "aqs": (-1, 5, SEMI_SHARP),
        "as": (-1, 5, SHARP),
        "atqs": (-1, 5, THREE_Q_SHARP),
        "ass": (-1, 5, DOUBLE_SHARP),
        "ax": (-1, 5, DOUBLE_SHARP),

        "bff": (-1, 6, DOUBLE_FLAT),
        "btqf": (-1, 6, THREE_Q_FLAT),
        "bf": (-1, 6, FLAT),
        "bqf": (-1, 6, SEMI_FLAT),
        "b": (-1, 6, NATURAL),
        "bqs": (-1, 6, SEMI_SHARP),
        "bs": (-1, 6, SHARP),
        "btqs": (-1, 6, THREE_Q_SHARP),
        "bss": (-1, 6, DOUBLE_SHARP),
        "bx": (-1, 6, DOUBLE_SHARP),

        "c-flatflat": (-1, 0, DOUBLE_FLAT),
        "c-flat": (-1, 0, FLAT),
        "c-natural": (-1, 0, NATURAL),
        "c-sharp": (-1, 0, SHARP),
        "c-sharpsharp": (-1, 0, DOUBLE_SHARP),

        "d-flatflat": (-1, 1, DOUBLE_FLAT),
        "d-flat": (-1, 1, FLAT),
        "d-natural": (-1, 1, NATURAL),
        "d-sharp": (-1, 1, SHARP),
        "d-sharpsharp": (-1, 1, DOUBLE_SHARP),

        "e-flatflat": (-1, 2, DOUBLE_FLAT),
        "e-flat": (-1, 2, FLAT),
        "e-natural": (-1, 2, NATURAL),
        "e-sharp": (-1, 2, SHARP),
        "e-sharpsharp": (-1, 2, DOUBLE_SHARP),

        "f-flatflat": (-1, 3, DOUBLE_FLAT),
        "f-flat": (-1, 3, FLAT),
        "f-natural": (-1, 3, NATURAL),
        "f-sharp": (-1, 3, SHARP),
        "f-sharpsharp": (-1, 3, DOUBLE_SHARP),

        "g-flatflat": (-1, 4, DOUBLE_FLAT),
        "g-flat": (-1, 4, FLAT),
        "g-natural": (-1, 4, NATURAL),
        "g-sharp": (-1, 4, SHARP),
        "g-sharpsharp": (-1, 4, DOUBLE_SHARP),

        "a-flatflat": (-1, 5, DOUBLE_FLAT),
        "a-flat": (-1, 5, FLAT),
        "a-natural": (-1, 5, NATURAL),
        "a-sharp": (-1, 5, SHARP),
        "a-sharpsharp": (-1, 5, DOUBLE_SHARP),

        "b-flatflat": (-1, 6, DOUBLE_FLAT),
        "b-flat": (-1, 6, FLAT),
        "b-natural": (-1, 6, NATURAL),
        "b-sharp": (-1, 6, SHARP),
        "b-sharpsharp": (-1, 6, DOUBLE_SHARP),
    },
    "espanol": {
        "dobb": (-1, 0, DOUBLE_FLAT),
        "dotcb": (-1, 0, THREE_Q_FLAT),
        "dob": (-1, 0, FLAT),
        "docb": (-1, 0, SEMI_FLAT),
        "do": (-1, 0, NATURAL),
        "docs": (-1, 0, SEMI_SHARP),
        "dos": (-1, 0, SHARP),
        "dotcs": (-1, 0, THREE_Q_SHARP),
        "doss": (-1, 0, DOUBLE_SHARP),
        "dox": (-1, 0, DOUBLE_SHARP),

        "rebb": (-1, 1, DOUBLE_FLAT),
        "retcb": (-1, 1, THREE_Q_FLAT),
        "reb": (-1, 1, FLAT),
        "recb": (-1, 1, SEMI_FLAT),
        "re": (-1, 1, NATURAL),
        "recs": (-1, 1, SEMI_SHARP),
        "res": (-1, 1, SHARP),
        "retcs": (-1, 1, THREE_Q_SHARP),
        "ress": (-1, 1, DOUBLE_SHARP),
        "rex": (-1, 1, DOUBLE_SHARP),

        "mibb": (-1, 2, DOUBLE_FLAT),
        "mitcb": (-1, 2, THREE_Q_FLAT),
        "mib": (-1, 2, FLAT),
        "micb": (-1, 2, SEMI_FLAT),
        "mi": (-1, 2, NATURAL),
        "mics": (-1, 2, SEMI_SHARP),
        "mis": (-1, 2, SHARP),
        "mitcs": (-1, 2, THREE_Q_SHARP),
        "miss": (-1, 2, DOUBLE_SHARP),
        "mix": (-1, 2, DOUBLE_SHARP),

        "fabb": (-1, 3, DOUBLE_FLAT),
        "fatcb": (-1, 3, THREE_Q_FLAT),
        "fab": (-1, 3, FLAT),
        "facb": (-1, 3, SEMI_FLAT),
        "fa": (-1, 3, NATURAL),
        "facs": (-1, 3, SEMI_SHARP),
        "fas": (-1, 3, SHARP),
        "fatcs": (-1, 3, THREE_Q_SHARP),
        "fass": (-1, 3, DOUBLE_SHARP),
        "fax": (-1, 3, DOUBLE_SHARP),

        "solbb": (-1, 4, DOUBLE_FLAT),
        "soltcb": (-1, 4, THREE_Q_FLAT),
        "solb": (-1, 4, FLAT),
        "solcb": (-1, 4, SEMI_FLAT),
        "sol": (-1, 4, NATURAL),
        "solcs": (-1, 4, SEMI_SHARP),
        "sols": (-1, 4, SHARP),
        "soltcs": (-1, 4, THREE_Q_SHARP),
        "solss": (-1, 4, DOUBLE_SHARP),
        "solx": (-1, 4, DOUBLE_SHARP),

        "labb": (-1, 5, DOUBLE_FLAT),
        "latcb": (-1, 5, THREE_Q_FLAT),
        "lab": (-1, 5, FLAT),
        "lacb": (-1, 5, SEMI_FLAT),
        "la": (-1, 5, NATURAL),
        "lacs": (-1, 5, SEMI_SHARP),
        "las": (-1, 5, SHARP),
        "latcs": (-1, 5, THREE_Q_SHARP),
        "lass": (-1, 5, DOUBLE_SHARP),
        "lax": (-1, 5, DOUBLE_SHARP),

        "sibb": (-1, 6, DOUBLE_FLAT),
        "sitcb": (-1, 6, THREE_Q_FLAT),
        "sib": (-1, 6, FLAT),
        "sicb": (-1, 6, SEMI_FLAT),
        "si": (-1, 6, NATURAL),
        "sics": (-1, 6, SEMI_SHARP),
        "sis": (-1, 6, SHARP),
        "sitcs": (-1, 6, THREE_Q_SHARP),
        "siss": (-1, 6, DOUBLE_SHARP),
        "six": (-1, 6, DOUBLE_SHARP),
    },
    "français": {
        "dobb": (-1, 0, DOUBLE_FLAT),
        "dobsb": (-1, 0, THREE_Q_FLAT),
        "dob": (-1, 0, FLAT),
        "dosb": (-1, 0, SEMI_FLAT),
        "do": (-1, 0, NATURAL),
        "dosd": (-1, 0, SEMI_SHARP),
        "dod": (-1, 0, SHARP),
        "dodsd": (-1, 0, THREE_Q_SHARP),
        "dodd": (-1, 0, DOUBLE_SHARP),
        "dox": (-1, 0, DOUBLE_SHARP),

        "rébb": (-1, 1, DOUBLE_FLAT),
        "rébsb": (-1, 1, THREE_Q_FLAT),
        "réb": (-1, 1, FLAT),
        "résb": (-1, 1, SEMI_FLAT),
        "ré": (-1, 1, NATURAL),
        "résd": (-1, 1, SEMI_SHARP),
        "réd": (-1, 1, SHARP),
        "rédsd": (-1, 1, THREE_Q_SHARP),
        "rédd": (-1, 1, DOUBLE_SHARP),
        "réx": (-1, 1, DOUBLE_SHARP),

        "rebb": (-1, 1, DOUBLE_FLAT),
        "rebsb": (-1, 1, THREE_Q_FLAT),
        "reb": (-1, 1, FLAT),
        "resb": (-1, 1, SEMI_FLAT),
        "re": (-1, 1, NATURAL),
        "resd": (-1, 1, SEMI_SHARP),
        "red": (-1, 1, SHARP),
        "redsd": (-1, 1, THREE_Q_SHARP),
        "redd": (-1, 1, DOUBLE_SHARP),
        "rex": (-1, 1, DOUBLE_SHARP),

        "mibb": (-1, 2, DOUBLE_FLAT),
        "mibsb": (-1, 2, THREE_Q_FLAT),
        "mib": (-1, 2, FLAT),
        "misb": (-1, 2, SEMI_FLAT),
        "mi": (-1, 2, NATURAL),
        "misd": (-1, 2, SEMI_SHARP),
        "mid": (-1, 2, SHARP),
        "midsd": (-1, 2, THREE_Q_SHARP),
        "midd": (-1, 2, DOUBLE_SHARP),
        "mix": (-1, 2, DOUBLE_SHARP),

        "fabb": (-1, 3, DOUBLE_FLAT),
        "fabsb": (-1, 3, THREE_Q_FLAT),
        "fab": (-1, 3, FLAT),
        "fasb": (-1, 3, SEMI_FLAT),
        "fa": (-1, 3, NATURAL),
        "fasd": (-1, 3, SEMI_SHARP),
        "fad": (-1, 3, SHARP),
        "fadsd": (-1, 3, THREE_Q_SHARP),
        "fadd": (-1, 3, DOUBLE_SHARP),
        "fax": (-1, 3, DOUBLE_SHARP),

        "solbb": (-1, 4, DOUBLE_FLAT),
        "solbsb": (-1, 4, THREE_Q_FLAT),
        "solb": (-1, 4, FLAT),
        "solsb": (-1, 4, SEMI_FLAT),
        "sol": (-1, 4, NATURAL),
        "solsd": (-1, 4, SEMI_SHARP),
        "sold": (-1, 4, SHARP),
        "soldsd": (-1, 4, THREE_Q_SHARP),
        "soldd": (-1, 4, DOUBLE_SHARP),
        "solx": (-1, 4, DOUBLE_SHARP),

        "labb": (-1, 5, DOUBLE_FLAT),
        "labsb": (-1, 5, THREE_Q_FLAT),
        "lab": (-1, 5, FLAT),
        "lasb": (-1, 5, SEMI_FLAT),
        "la": (-1, 5, NATURAL),
        "lasd": (-1, 5, SEMI_SHARP),
        "lad": (-1, 5, SHARP),
        "ladsd": (-1, 5, THREE_Q_SHARP),
        "ladd": (-1, 5, DOUBLE_SHARP),
        "lax": (-1, 5, DOUBLE_SHARP),

        "sibb": (-1, 6, DOUBLE_FLAT),
        "sibsb": (-1, 6, THREE_Q_FLAT),
        "sib": (-1, 6, FLAT),
        "sisb": (-1, 6, SEMI_FLAT),
        "si": (-1, 6, NATURAL),
        "sisd": (-1, 6, SEMI_SHARP),
        "sid": (-1, 6, SHARP),
        "sidsd": (-1, 6, THREE_Q_SHARP),
        "sidd": (-1, 6, DOUBLE_SHARP),
        "six": (-1, 6, DOUBLE_SHARP),
    },
    "italiano": {
        "dobb": (-1, 0, DOUBLE_FLAT),
        "dobsb": (-1, 0, THREE_Q_FLAT),
        "dob": (-1, 0, FLAT),
        "dosb": (-1, 0, SEMI_FLAT),
        "do": (-1, 0, NATURAL),
        "dosd": (-1, 0, SEMI_SHARP),
        "dod": (-1, 0, SHARP),
        "dodsd": (-1, 0, THREE_Q_SHARP),
        "dodd": (-1, 0, DOUBLE_SHARP),

        "rebb": (-1, 1, DOUBLE_FLAT),
        "rebsb": (-1, 1, THREE_Q_FLAT),
        "reb": (-1, 1, FLAT),
        "resb": (-1, 1, SEMI_FLAT),
        "re": (-1, 1, NATURAL),
        "resd": (-1, 1, SEMI_SHARP),
        "red": (-1, 1, SHARP),
        "redsd": (-1, 1, THREE_Q_SHARP),
        "redd": (-1, 1, DOUBLE_SHARP),

        "mibb": (-1, 2, DOUBLE_FLAT),
        "mibsb": (-1, 2, THREE_Q_FLAT),
        "mib": (-1, 2, FLAT),
        "misb": (-1, 2, SEMI_FLAT),
        "mi": (-1, 2, NATURAL),
        "misd": (-1, 2, SEMI_SHARP),
        "mid": (-1, 2, SHARP),
        "midsd": (-1, 2, THREE_Q_SHARP),
        "midd": (-1, 2, DOUBLE_SHARP),

        "fabb": (-1, 3, DOUBLE_FLAT),
        "fabsb": (-1, 3, THREE_Q_FLAT),
        "fab": (-1, 3, FLAT),
        "fasb": (-1, 3, SEMI_FLAT),
        "fa": (-1, 3, NATURAL),
        "fasd": (-1, 3, SEMI_SHARP),
        "fad": (-1, 3, SHARP),
        "fadsd": (-1, 3, THREE_Q_SHARP),
        "fadd": (-1, 3, DOUBLE_SHARP),

        "solbb": (-1, 4, DOUBLE_FLAT),
        "solbsb": (-1, 4, THREE_Q_FLAT),
        "solb": (-1, 4, FLAT),
        "solsb": (-1, 4, SEMI_FLAT),
        "sol": (-1, 4, NATURAL),
        "solsd": (-1, 4, SEMI_SHARP),
        "sold": (-1, 4, SHARP),
        "soldsd": (-1, 4, THREE_Q_SHARP),
        "soldd": (-1, 4, DOUBLE_SHARP),

        "labb": (-1, 5, DOUBLE_FLAT),
        "labsb": (-1, 5, THREE_Q_FLAT),
        "lab": (-1, 5, FLAT),
        "lasb": (-1, 5, SEMI_FLAT),
        "la": (-1, 5, NATURAL),
        "lasd": (-1, 5, SEMI_SHARP),
        "lad": (-1, 5, SHARP),
        "ladsd": (-1, 5, THREE_Q_SHARP),
        "ladd": (-1, 5, DOUBLE_SHARP),

        "sibb": (-1, 6, DOUBLE_FLAT),
        "sibsb": (-1, 6, THREE_Q_FLAT),
        "sib": (-1, 6, FLAT),
        "sisb": (-1, 6, SEMI_FLAT),
        "si": (-1, 6, NATURAL),
        "sisd": (-1, 6, SEMI_SHARP),
        "sid": (-1, 6, SHARP),
        "sidsd": (-1, 6, THREE_Q_SHARP),
        "sidd": (-1, 6, DOUBLE_SHARP),
    },
    "norsk": {
        "ceses": (-1, 0, DOUBLE_FLAT),
        "cessess": (-1, 0, DOUBLE_FLAT),
        "ces": (-1, 0, FLAT),
        "cess": (-1, 0, FLAT),
        "c": (-1, 0, NATURAL),
        "cis": (-1, 0, SHARP),
        "ciss": (-1, 0, SHARP),
        "cisis": (-1, 0, DOUBLE_SHARP),
        "cississ": (-1, 0, DOUBLE_SHARP),

        "deses": (-1, 1, DOUBLE_FLAT),
        "dessess": (-1, 1, DOUBLE_FLAT),
        "des": (-1, 1, FLAT),
        "dess": (-1, 1, FLAT),
        "d": (-1, 1, NATURAL),
        "dis": (-1, 1, SHARP),
        "diss": (-1, 1, SHARP),
        "disis": (-1, 1, DOUBLE_SHARP),
        "dississ": (-1, 1, DOUBLE_SHARP),

        "eeses": (-1, 2, DOUBLE_FLAT),
        "eessess": (-1, 2, DOUBLE_FLAT),
        "eses": (-1, 2, DOUBLE_FLAT),
        "essess": (-1, 2, DOUBLE_FLAT),
        "ees": (-1, 2, FLAT),
        "eess": (-1, 2, FLAT),
        "es": (-1, 2, FLAT),
        "ess": (-1, 2, FLAT),
        "e": (-1, 2, NATURAL),
        "eis": (-1, 2, SHARP),
        "eiss": (-1, 2, SHARP),
        "eisis": (-1, 2, DOUBLE_SHARP),
        "eississ": (-1, 2, DOUBLE_SHARP),

        "feses": (-1, 3, DOUBLE_FLAT),
        "fessess": (-1, 3, DOUBLE_FLAT),
        "fes": (-1, 3, FLAT),
        "fess": (-1, 3, FLAT),
        "f": (-1, 3, NATURAL),
        "fis": (-1, 3, SHARP),
        "fiss": (-1, 3, SHARP),
        "fisis": (-1, 3, DOUBLE_SHARP),
        "fississ": (-1, 3, DOUBLE_SHARP),

        "geses": (-1, 4, DOUBLE_FLAT),
        "gessess": (-1, 4, DOUBLE_FLAT),
        "ges": (-1, 4, FLAT),
        "gess": (-1, 4, FLAT),
        "g": (-1, 4, NATURAL),
        "g": (-1, 4, NATURAL),
        "gis": (-1, 4, SHARP),
        "giss": (-1, 4, SHARP),
        "gisis": (-1, 4, DOUBLE_SHARP),
        "gississ": (-1, 4, DOUBLE_SHARP),

        "aeses": (-1, 5, DOUBLE_FLAT),
        "aessess": (-1, 5, DOUBLE_FLAT),
        "ases": (-1, 5, DOUBLE_FLAT),
        "assess": (-1, 5, DOUBLE_FLAT),
        "aes": (-1, 5, FLAT),
        "aess": (-1, 5, FLAT),
        "as": (-1, 5, FLAT),
        "ass": (-1, 5, FLAT),
        "a": (-1, 5, NATURAL),
        "ais": (-1, 5, SHARP),
        "aiss": (-1, 5, SHARP),
        "aisis": (-1, 5, DOUBLE_SHARP),
        "aississ": (-1, 5, DOUBLE_SHARP),

        "bes": (-1, 6, DOUBLE_FLAT),
        "bess": (-1, 6, DOUBLE_FLAT),
        "b": (-1, 6, FLAT),
        "b": (-1, 6, FLAT),
        "h": (-1, 6, NATURAL),
        "his": (-1, 6, SHARP),
        "hiss": (-1, 6, SHARP),
        "hisis": (-1, 6, DOUBLE_SHARP),
        "hississ": (-1, 6, DOUBLE_SHARP),
    },
    "portugues": {
        "dobb": (-1, 0, DOUBLE_FLAT),
        "dobtqt": (-1, 0, THREE_Q_FLAT),
        "dob": (-1, 0, FLAT),
        "dobqt": (-1, 0, SEMI_FLAT),
        "do": (-1, 0, NATURAL),
        "dosqt": (-1, 0, SEMI_SHARP),
        "dos": (-1, 0, SHARP),
        "dostqt": (-1, 0, THREE_Q_SHARP),
        "doss": (-1, 0, DOUBLE_SHARP),

        "rebb": (-1, 1, DOUBLE_FLAT),
        "rebtqt": (-1, 1, THREE_Q_FLAT),
        "reb": (-1, 1, FLAT),
        "rebqt": (-1, 1, SEMI_FLAT),
        "re": (-1, 1, NATURAL),
        "resqt": (-1, 1, SEMI_SHARP),
        "res": (-1, 1, SHARP),
        "restqt": (-1, 1, THREE_Q_SHARP),
        "ress": (-1, 1, DOUBLE_SHARP),

        "mibb": (-1, 2, DOUBLE_FLAT),
        "mibtqt": (-1, 2, THREE_Q_FLAT),
        "mib": (-1, 2, FLAT),
        "mibqt": (-1, 2, SEMI_FLAT),
        "mi": (-1, 2, NATURAL),
        "misqt": (-1, 2, SEMI_SHARP),
        "mis": (-1, 2, SHARP),
        "mistqt": (-1, 2, THREE_Q_SHARP),
        "miss": (-1, 2, DOUBLE_SHARP),

        "fabb": (-1, 3, DOUBLE_FLAT),
        "fabtqt": (-1, 3, THREE_Q_FLAT),
        "fab": (-1, 3, FLAT),
        "fabqt": (-1, 3, SEMI_FLAT),
        "fa": (-1, 3, NATURAL),
        "fasqt": (-1, 3, SEMI_SHARP),
        "fas": (-1, 3, SHARP),
        "fastqt": (-1, 3, THREE_Q_SHARP),
        "fass": (-1, 3, DOUBLE_SHARP),

        "solbb": (-1, 4, DOUBLE_FLAT),
        "solbtqt": (-1, 4, THREE_Q_FLAT),
        "solb": (-1, 4, FLAT),
        "solbqt": (-1, 4, SEMI_FLAT),
        "sol": (-1, 4, NATURAL),
        "solsqt": (-1, 4, SEMI_SHARP),
        "sols": (-1, 4, SHARP),
        "solstqt": (-1, 4, THREE_Q_SHARP),
        "solss": (-1, 4, DOUBLE_SHARP),

        "labb": (-1, 5, DOUBLE_FLAT),
        "labtqt": (-1, 5, THREE_Q_FLAT),
        "lab": (-1, 5, FLAT),
        "labqt": (-1, 5, SEMI_FLAT),
        "la": (-1, 5, NATURAL),
        "lasqt": (-1, 5, SEMI_SHARP),
        "las": (-1, 5, SHARP),
        "lastqt": (-1, 5, THREE_Q_SHARP),
        "lass": (-1, 5, DOUBLE_SHARP),

        "sibb": (-1, 6, DOUBLE_FLAT),
        "sibtqt": (-1, 6, THREE_Q_FLAT),
        "sib": (-1, 6, FLAT),
        "sibqt": (-1, 6, SEMI_FLAT),
        "si": (-1, 6, NATURAL),
        "sisqt": (-1, 6, SEMI_SHARP),
        "sis": (-1, 6, SHARP),
        "sistqt": (-1, 6, THREE_Q_SHARP),
        "siss": (-1, 6, DOUBLE_SHARP),
    },
    "suomi": {
        "ceses": (-1, 0, DOUBLE_FLAT),
        "ces": (-1, 0, FLAT),
        "c": (-1, 0, NATURAL),
        "cis": (-1, 0, SHARP),
        "cisis": (-1, 0, DOUBLE_SHARP),

        "deses": (-1, 1, DOUBLE_FLAT),
        "des": (-1, 1, FLAT),
        "d": (-1, 1, NATURAL),
        "dis": (-1, 1, SHARP),
        "disis": (-1, 1, DOUBLE_SHARP),

        "eses": (-1, 2, DOUBLE_FLAT),
        "es": (-1, 2, FLAT),
        "e": (-1, 2, NATURAL),
        "eis": (-1, 2, SHARP),
        "eisis": (-1, 2, DOUBLE_SHARP),

        "feses": (-1, 3, DOUBLE_FLAT),
        "fes": (-1, 3, FLAT),
        "f": (-1, 3, NATURAL),
        "fis": (-1, 3, SHARP),
        "fisis": (-1, 3, DOUBLE_SHARP),

        "geses": (-1, 4, DOUBLE_FLAT),
        "ges": (-1, 4, FLAT),
        "g": (-1, 4, NATURAL),
        "gis": (-1, 4, SHARP),
        "gisis": (-1, 4, DOUBLE_SHARP),

        "asas": (-1, 5, DOUBLE_FLAT),
        "ases": (-1, 5, DOUBLE_FLAT),   # non-standard name for asas
        "as": (-1, 5, FLAT),
        "a": (-1, 5, NATURAL),
        "ais": (-1, 5, SHARP),
        "aisis": (-1, 5, DOUBLE_SHARP),

        "bb": (-1, 6, DOUBLE_FLAT),    # should be bes; kept for backward compatibility
        "bes": (-1, 6, DOUBLE_FLAT),
        "heses": (-1, 6, DOUBLE_FLAT),  # non-standard name for bb
        "b": (-1, 6, FLAT),
        "h": (-1, 6, NATURAL),
        "his": (-1, 6, SHARP),
        "hisis": (-1, 6, DOUBLE_SHARP),
    },
    "svenska": {
        "cessess": (-1, 0, DOUBLE_FLAT),
        "cess": (-1, 0, FLAT),
        "c": (-1, 0, NATURAL),
        "ciss": (-1, 0, SHARP),
        "cississ": (-1, 0, DOUBLE_SHARP),

        "dessess": (-1, 1, DOUBLE_FLAT),
        "dess": (-1, 1, FLAT),
        "d": (-1, 1, NATURAL),
        "diss": (-1, 1, SHARP),
        "dississ": (-1, 1, DOUBLE_SHARP),

        "essess": (-1, 2, DOUBLE_FLAT),
        "ess": (-1, 2, FLAT),
        "e": (-1, 2, NATURAL),
        "eiss": (-1, 2, SHARP),
        "eississ": (-1, 2, DOUBLE_SHARP),

        "fessess": (-1, 3, DOUBLE_FLAT),
        "fess": (-1, 3, FLAT),
        "f": (-1, 3, NATURAL),
        "fiss": (-1, 3, SHARP),
        "fississ": (-1, 3, DOUBLE_SHARP),

        "gessess": (-1, 4, DOUBLE_FLAT),
        "gess": (-1, 4, FLAT),
        "g": (-1, 4, NATURAL),
        "giss": (-1, 4, SHARP),
        "gississ": (-1, 4, DOUBLE_SHARP),

        "assess": (-1, 5, DOUBLE_FLAT),
        "ass": (-1, 5, FLAT),
        "a": (-1, 5, NATURAL),
        "aiss": (-1, 5, SHARP),
        "aississ": (-1, 5, DOUBLE_SHARP),

        "hessess": (-1, 6, DOUBLE_FLAT),
        "b": (-1, 6, FLAT),
        "h": (-1, 6, NATURAL),
        "hiss": (-1, 6, SHARP),
        "hississ": (-1, 6, DOUBLE_SHARP),
    },
    "vlaams": {
        "dobb": (-1, 0, DOUBLE_FLAT),
        "dob": (-1, 0, FLAT),
        "do": (-1, 0, NATURAL),
        "dok": (-1, 0, SHARP),
        "dokk": (-1, 0, DOUBLE_SHARP),

        "rebb": (-1, 1, DOUBLE_FLAT),
        "reb": (-1, 1, FLAT),
        "re": (-1, 1, NATURAL),
        "rek": (-1, 1, SHARP),
        "rekk": (-1, 1, DOUBLE_SHARP),

        "mibb": (-1, 2, DOUBLE_FLAT),
        "mib": (-1, 2, FLAT),
        "mi": (-1, 2, NATURAL),
        "mik": (-1, 2, SHARP),
        "mikk": (-1, 2, DOUBLE_SHARP),

        "fabb": (-1, 3, DOUBLE_FLAT),
        "fab": (-1, 3, FLAT),
        "fa": (-1, 3, NATURAL),
        "fak": (-1, 3, SHARP),
        "fakk": (-1, 3, DOUBLE_SHARP),

        "solbb": (-1, 4, DOUBLE_FLAT),
        "solb": (-1, 4, FLAT),
        "sol": (-1, 4, NATURAL),
        "solk": (-1, 4, SHARP),
        "solkk": (-1, 4, DOUBLE_SHARP),

        "labb": (-1, 5, DOUBLE_FLAT),
        "lab": (-1, 5, FLAT),
        "la": (-1, 5, NATURAL),
        "lak": (-1, 5, SHARP),
        "lakk": (-1, 5, DOUBLE_SHARP),

        "sibb": (-1, 6, DOUBLE_FLAT),
        "sib": (-1, 6, FLAT),
        "si": (-1, 6, NATURAL),
        "sik": (-1, 6, SHARP),
        "sikk": (-1, 6, DOUBLE_SHARP),
    },
    "bagpipe": {
        "G": (0, 4, NATURAL),
        "a": (0, 5, NATURAL),
        "b": (0, 6, NATURAL),
        "c": (1, 0, SHARP),
        "c-flat": (1, 0, FLAT),
        "cflat": (1, 0, FLAT),
        "d": (1, 1, NATURAL),
        "e": (1, 2, NATURAL),
        "f": (1, 3, SHARP),
        "f-flat": (1, 3, FLAT),
        "fflat": (1, 3, FLAT),
        "g": (1, 4, NATURAL),
        "g-flat": (1, 4, FLAT),
        "gflat": (1, 4, FLAT),
        "A": (1, 5, NATURAL),
        "B": (1, 6, NATURAL),
        "C": (2, 0, SHARP),
    },
}

# a set with all the pitch names for fast membership testing
all_pitch_names = frozenset(name for d in pitch_names.values() for name in d)

# some synonyms
pitch_names["español"] = pitch_names["espanol"]
pitch_names["português"] = pitch_names["portugues"]
pitch_names["català"] = pitch_names["catalan"]


drum_pitch_longnames = {
    'acousticbassdrum': (-3, 6, NATURAL),
    'bassdrum': (-2, 0, NATURAL),
    'hisidestick': (-3, 6, DOUBLE_SHARP),
    'sidestick': (-2, 0, SHARP),
    'losidestick': (-2, 1, FLAT),
    'acousticsnare': (-2, 1, NATURAL),
    'snare': (-2, 2, DOUBLE_FLAT),
    'handclap': (-2, 1, SHARP),
    'electricsnare': (-2, 2, NATURAL),
    'lowfloortom': (-2, 3, NATURAL),
    'closedhihat': (-2, 3, SHARP),
    'hihat': (-2, 4, FLAT),
    'highfloortom': (-2, 4, NATURAL),
    'pedalhihat': (-2, 4, SHARP),
    'lowtom': (-2, 5, NATURAL),
    'openhihat': (-2, 5, SHARP),
    'halfopenhihat': (-2, 5, SHARP),
    'lowmidtom': (-2, 6, NATURAL),
    'himidtom': (-1, 0, NATURAL),
    'crashcymbala': (-1, 0, SHARP),
    'crashcymbal': (-1, 1, FLAT),
    'hightom': (-1, 1, NATURAL),
    'ridecymbala': (-1, 1, SHARP),
    'ridecymbal': (-1, 2, FLAT),
    'chinesecymbal': (-1, 2, NATURAL),
    'ridebell': (-1, 3, NATURAL),
    'tambourine': (-1, 3, SHARP),
    'splashcymbal': (-1, 4, NATURAL),
    'cowbell': (-1, 4, SHARP),
    'crashcymbalb': (-1, 5, NATURAL),
    'vibraslap': (-1, 5, SHARP),
    'ridecymbalb': (-1, 6, NATURAL),
    'mutehibongo': (-1, 6, SHARP),
    'hibongo': (0, 0, NATURAL),
    'openhibongo': (0, 1, DOUBLE_FLAT),
    'mutelobongo': (-1, 6, DOUBLE_SHARP),
    'lobongo': (0, 0, SHARP),
    'openlobongo': (0, 1, FLAT),
    'mutehiconga': (0, 1, NATURAL),
    'muteloconga': (0, 2, DOUBLE_FLAT),
    'openhiconga': (0, 1, SHARP),
    'hiconga': (0, 2, FLAT),
    'openloconga': (0, 1, DOUBLE_SHARP),
    'loconga': (0, 2, NATURAL),
    'hitimbale': (0, 3, NATURAL),
    'lotimbale': (0, 3, SHARP),
    'hiagogo': (0, 4, NATURAL),
    'loagogo': (0, 4, SHARP),
    'cabasa': (0, 5, NATURAL),
    'maracas': (0, 5, SHARP),
    'shortwhistle': (0, 6, NATURAL),
    'longwhistle': (1, 0, NATURAL),
    'shortguiro': (1, 0, SHARP),
    'longguiro': (1, 1, NATURAL),
    'guiro': (1, 0, DOUBLE_SHARP),
    'claves': (1, 1, SHARP),
    'hiwoodblock': (1, 2, NATURAL),
    'lowoodblock': (1, 3, NATURAL),
    'mutecuica': (1, 3, SHARP),
    'opencuica': (1, 4, NATURAL),
    'mutetriangle': (1, 4, SHARP),
    'triangle': (1, 4, DOUBLE_SHARP),
    'opentriangle': (1, 5, NATURAL),
    # 'transposing' pitches:
    'oneup': (0, 1, NATURAL),
    'twoup': (0, 2, NATURAL),
    'threeup': (0, 3, NATURAL),
    'fourup': (0, 4, NATURAL),
    'fiveup': (0, 5, NATURAL),
    'onedown': (-1, 6, NATURAL),
    'twodown': (-1, 5, NATURAL),
    'threedown': (-1, 4, NATURAL),
    'fourdown': (-1, 3, NATURAL),
    'fivedown': (-1, 2, NATURAL),
}

drum_pitch_shortnames = {
    'bda': 'acousticbassdrum',
    'bd': 'bassdrum',
    'ssh': 'hisidestick',
    'ss': 'sidestick',
    'ssl': 'losidestick',
    'sna': 'acousticsnare',
    'sn': 'snare',
    'hc': 'handclap',
    'sne': 'electricsnare',
    'tomfl': 'lowfloortom',
    'hhc': 'closedhihat',
    'hh': 'hihat',
    'tomfh': 'highfloortom',
    'hhp': 'pedalhihat',
    'toml': 'lowtom',
    'hho': 'openhihat',
    'hhho': 'halfopenhihat',
    'tomml': 'lowmidtom',
    'tommh': 'himidtom',
    'cymca': 'crashcymbala',
    'cymc': 'crashcymbal',
    'tomh': 'hightom',
    'cymra': 'ridecymbala',
    'cymr': 'ridecymbal',
    'cymch': 'chinesecymbal',
    'rb': 'ridebell',
    'tamb': 'tambourine',
    'cyms': 'splashcymbal',
    'cb': 'cowbell',
    'cymcb': 'crashcymbalb',
    'vibs': 'vibraslap',
    'cymrb': 'ridecymbalb',
    'bohm': 'mutehibongo',
    'boh': 'hibongo',
    'boho': 'openhibongo',
    'bolm': 'mutelobongo',
    'bol': 'lobongo',
    'bolo': 'openlobongo',
    'cghm': 'mutehiconga',
    'cglm': 'muteloconga',
    'cgho': 'openhiconga',
    'cgh': 'hiconga',
    'cglo': 'openloconga',
    'cgl': 'loconga',
    'timh': 'hitimbale',
    'timl': 'lotimbale',
    'agh': 'hiagogo',
    'agl': 'loagogo',
    'cab': 'cabasa',
    'mar': 'maracas',
    'whs': 'shortwhistle',
    'whl': 'longwhistle',
    'guis': 'shortguiro',
    'guil': 'longguiro',
    'gui': 'guiro',
    'cl': 'claves',
    'wbh': 'hiwoodblock',
    'wbl': 'lowoodblock',
    'cuim': 'mutecuica',
    'cuio': 'opencuica',
    'trim': 'mutetriangle',
    'tri': 'triangle',
    'trio': 'opentriangle',
    'tt': 'tamtam',
    'ua': 'oneup',
    'ub': 'twoup',
    'uc': 'threeup',
    'ud': 'fourup',
    'ue': 'fiveup',
    'da': 'onedown',
    'db': 'twodown',
    'dc': 'threedown',
    'dd': 'fourdown',
    'de': 'fivedown',
}


drum_pitch_names = dict(drum_pitch_longnames)
drum_pitch_names.update((short_name, drum_pitch_longnames.get(long_name))
    for short_name, long_name in drum_pitch_shortnames.items())


rests = tuple("Rrs")


durations = (
    '\\maxima', '\\longa', '\\breve',
    '1', '2', '4', '8', '16', '32', '64', '128', '256', '512', '1024', '2048',
)


# http://lilypond.org/doc/latest/Documentation/usage/music-fragment-options
lilypond_book_options = (
    "staffsize",
    "ragged-right",
    "noragged-right",
    "line-width",
    "papersize",
    "paper-width",
    "paper-height",
    "notime",
    "fragment",
    "nofragment",
    "inline",
    "indent",
    "noindent",
    "quote",
    "exampleindent",
    "relative",
    "verbatim",
    "texidoc",
    "doctitle",
    "nogettext",
    "printfilename",
)

lilypond_book_units = (
    "cm",
    "mm",
    "in",
    "pt",
)
